#include <stdexcept>
#include "regmatch.h"

using namespace std;

namespace Msp {

RegMatch::RegMatch(const string &str, const GroupArray &g):
	groups(g)
{
	for(GroupArray::iterator i=groups.begin(); i!=groups.end(); ++i)
		if(i->match)
		{
			i->length = i->end-i->begin;
			i->str = str.substr(i->begin, i->length);
		}
}

const RegMatch::Group &RegMatch::group(unsigned i) const
{
	if(i>=groups.size())
		throw out_of_range("RegMatch::group");
	return groups[i];
}

} // namespace Msp
